// pins hard coded
// D2  RTC IRQ 
// D13 debug LED

/*
  Open Hive | RTC set and read time
  2016-09 Clemens Gruber | initial version

  This code is in the public domain.
*/

// libraries 
// RTC 
#include <Wire.h>    // I2C (for RTC)
#include <DS3231.h>  // RTC itself 

DS3231 RTC;                     // create RTC object for DS3231

// we need some variable as char to pass it to payload easily 
char timestampChar[20];  // should handle yyyy/mm/dd hh:mm:ss and null terminator 


void setup () {
  // debug
  Serial.begin(9600);

  // rtc
  Wire.begin();
  RTC.begin();
  // set rtc with date and time the compiler was running
  RTC.adjust(DateTime(__DATE__, __TIME__));
}


void loop () {
  // output timestamp
  getTimestamp();
  Serial.println(timestampChar); 
  
  // wait 1 second
  delay(1000);  
} 


// timestamp 
void getTimestamp() {   
  DateTime currentTime = RTC.now();  // get the current date-time   
  snprintf(timestampChar, sizeof(timestampChar), "%d/%02d/%02d %02d:%02d:%02d", currentTime.year(), currentTime.month(), currentTime.date(), currentTime.hour(), currentTime.minute(), currentTime.second());  // write to char array 
}
